//
// File name          :uart.v
// Module name        :uart.v
// Created by         :GaoYun Semi
// Author             :(Winson)
// Created On         :2020-11-05 14:26 GuangZhou
// Last Modified      :
// Update Count       :2020-11-05 14:26
// Description        :
//----------------------------------------------------------------------
//===========================================
module usb_uart_config 
(
    input              PHY_CLKOUT        , // clock
    input              RESET_IN        , // reset
        // UART INTERFACE
    input              setup_active   ,
    input   [3:0]      endpt_sel   ,
    input              usb_rxval   ,
    input              usb_rxact   ,
    input   [7:0]      usb_rxdat   ,

    input              usb_txact   ,
    input              usb_txpop   ,
    output  [11:0]     txdat_len_o,   

    output             jtag_tck          ,

    output  [7:0]      uart_endpt0_dat_o,
    output             uart_endpt0_send_o,

    output             uart1_en_o        ,
    output  [31:0]     uart1_BAUD_RATE_o ,
    output  [7:0]      uart1_PARITY_BIT_o,
    output  [7:0]      uart1_STOP_BIT_o  ,
    output  [7:0]      uart1_DATA_BITS_o  
/*	
    output             uart2_en_o        ,
    output  [31:0]     uart2_BAUD_RATE_o ,
    output  [7:0]      uart2_PARITY_BIT_o,
    output  [7:0]      uart2_STOP_BIT_o  ,
    output  [7:0]      uart2_DATA_BITS_o ,
	
    output             uart3_en_o        ,
    output  [31:0]     uart3_BAUD_RATE_o ,
    output  [7:0]      uart3_PARITY_BIT_o,
    output  [7:0]      uart3_STOP_BIT_o  ,
    output  [7:0]      uart3_DATA_BITS_o ,
	
	output             uart4_en_o        ,
    output  [31:0]     uart4_BAUD_RATE_o ,
    output  [7:0]      uart4_PARITY_BIT_o,
    output  [7:0]      uart4_STOP_BIT_o  ,
    output  [7:0]      uart4_DATA_BITS_o ,
	
	output             uart5_en_o        ,
    output  [31:0]     uart5_BAUD_RATE_o ,
    output  [7:0]      uart5_PARITY_BIT_o,
    output  [7:0]      uart5_STOP_BIT_o  ,
    output  [7:0]      uart5_DATA_BITS_o ,
	
	output             uart6_en_o        ,
    output  [31:0]     uart6_BAUD_RATE_o ,
    output  [7:0]      uart6_PARITY_BIT_o,
    output  [7:0]      uart6_STOP_BIT_o  ,
    output  [7:0]      uart6_DATA_BITS_o ,
	
	output             uart7_en_o        ,
    output  [31:0]     uart7_BAUD_RATE_o ,
    output  [7:0]      uart7_PARITY_BIT_o,
    output  [7:0]      uart7_STOP_BIT_o  ,
    output  [7:0]      uart7_DATA_BITS_o 
*/
);

parameter ENDPT_UART_CONFIG =4'h0;
parameter INTERFACE_UART1  =4'h0;
parameter INTERFACE_UART2  =4'h1;
parameter INTERFACE_UART3  =4'h2;
parameter INTERFACE_UART4  =4'h3;
parameter INTERFACE_UART5  =4'h4;
parameter INTERFACE_UART6  =4'h5;
parameter INTERFACE_UART7  =4'h6;


localparam  SET_LINE_CODING = 8'h20;
localparam  GET_LINE_CODING = 8'h21;
localparam  SET_CONTROL_LINE_STATE = 8'h22;

reg [7:0] stage;
reg [7:0] sub_stage;
reg [7:0] s_req_type;
reg [7:0] s_req_code;
reg [15:0]s_ctl_sig;
reg [15:0]s_set_len;
reg [15:0]s_interface_num;

reg       s_uart1_en;
//reg       s_uart1_en, s_uart2_en, s_uart3_en, s_uart4_en;
//reg       s_uart5_en, s_uart6_en, s_uart7_en;

reg [31:0]s_dte1_rate;
reg [7:0] s_char1_format;
reg [7:0] s_parity1_type;
reg [7:0] s_data1_bits;

//reg [31:0]s_dte2_rate;
//reg [7:0] s_char2_format;
//reg [7:0] s_parity2_type;
//reg [7:0] s_data2_bits;

//reg [31:0]s_dte3_rate;
//reg [7:0] s_char3_format;
//reg [7:0] s_parity3_type;
//reg [7:0] s_data3_bits;

//reg [31:0]s_dte4_rate;
//reg [7:0] s_char4_format;
//reg [7:0] s_parity4_type;
//reg [7:0] s_data4_bits;

//reg [31:0]s_dte5_rate;
//reg [7:0] s_char5_format;
//reg [7:0] s_parity5_type;
//reg [7:0] s_data5_bits;

//reg [31:0]s_dte6_rate;
//reg [7:0] s_char6_format;
//reg [7:0] s_parity6_type;
//reg [7:0] s_data6_bits;

//reg [31:0]s_dte7_rate;
//reg [7:0] s_char7_format;
//reg [7:0] s_parity7_type;
//reg [7:0] s_data7_bits;


reg [7:0] endpt0_dat;
reg       endpt0_send;

//reg       jtag_tck;
reg       jtag_tck_bf;
reg [7:0] jtag_tck_cnt;
reg [7:0] jtag_tck_div;
reg [7:0] jtag_base_addr;
reg [7:0] jtag_offect_addr;
reg [7:0] jtag_reg_1;

assign uart1_en_o=s_uart1_en;
assign uart1_BAUD_RATE_o=s_dte1_rate;
assign uart1_PARITY_BIT_o=s_parity1_type;
assign uart1_STOP_BIT_o=s_char1_format;
assign uart1_DATA_BITS_o=s_data1_bits;

//assign uart2_en_o=s_uart2_en;
//assign uart2_BAUD_RATE_o=s_dte2_rate;
//assign uart2_PARITY_BIT_o=s_parity2_type;
//assign uart2_STOP_BIT_o=s_char2_format;
//assign uart2_DATA_BITS_o=s_data2_bits;

//assign uart3_en_o=s_uart3_en;
//assign uart3_BAUD_RATE_o=s_dte3_rate;
//assign uart3_PARITY_BIT_o=s_parity3_type;
//assign uart3_STOP_BIT_o=s_char3_format;
//assign uart3_DATA_BITS_o=s_data3_bits;

//assign uart4_en_o=s_uart4_en;
//assign uart4_BAUD_RATE_o=s_dte4_rate;
//assign uart4_PARITY_BIT_o=s_parity4_type;
//assign uart4_STOP_BIT_o=s_char4_format;
//assign uart4_DATA_BITS_o=s_data4_bits;

//assign uart5_en_o=s_uart5_en;
//assign uart5_BAUD_RATE_o=s_dte5_rate;
//assign uart5_PARITY_BIT_o=s_parity5_type;
//assign uart5_STOP_BIT_o=s_char5_format;
//assign uart5_DATA_BITS_o=s_data5_bits;

//assign uart6_en_o=s_uart6_en;
//assign uart6_BAUD_RATE_o=s_dte6_rate;
//assign uart6_PARITY_BIT_o=s_parity6_type;
//assign uart6_STOP_BIT_o=s_char6_format;
//assign uart6_DATA_BITS_o=s_data6_bits;

//assign uart7_en_o=s_uart7_en;
//assign uart7_BAUD_RATE_o=s_dte7_rate;
//assign uart7_PARITY_BIT_o=s_parity7_type;
//assign uart7_STOP_BIT_o=s_char7_format;
//assign uart7_DATA_BITS_o=s_data7_bits;


assign uart_endpt0_dat_o=endpt0_dat;
assign uart_endpt0_send_o=endpt0_send;
assign txdat_len_o=12'd7;


always @(posedge PHY_CLKOUT,posedge RESET_IN) begin
    if (RESET_IN) begin
        stage <= 8'd0;
        sub_stage <= 8'd0;
        s_req_type <= 8'd0;
        s_req_code <= 8'd0;
        s_ctl_sig <= 16'd0;
        s_set_len <= 16'd0;
        s_interface_num<= 16'd0;
		
        s_dte1_rate <= 32'd115200;
        s_char1_format <= 8'd0;
        s_parity1_type <= 8'd0;
        s_data1_bits <= 8'd8;
		
//        s_dte2_rate <= 32'd115200;
//        s_char2_format <= 8'd0;
//        s_parity2_type <= 8'd0;
//        s_data2_bits <= 8'd8;
//		
//        s_dte3_rate <= 32'd115200;
//        s_char3_format <= 8'd0;
//        s_parity3_type <= 8'd0;
//        s_data3_bits <= 8'd8;
//		
//		s_dte4_rate <= 32'd115200;
//        s_char4_format <= 8'd0;
//        s_parity4_type <= 8'd0;
//        s_data4_bits <= 8'd8;
//		
//		s_dte5_rate <= 32'd115200;
//        s_char5_format <= 8'd0;
//        s_parity5_type <= 8'd0;
//        s_data5_bits <= 8'd8;
//		
//		s_dte6_rate <= 32'd115200;
//        s_char6_format <= 8'd0;
//        s_parity6_type <= 8'd0;
//        s_data6_bits <= 8'd8;
//		
//		s_dte7_rate <= 32'd115200;
//        s_char7_format <= 8'd0;
//        s_parity7_type <= 8'd0;
//        s_data7_bits <= 8'd8;
		
        endpt0_send <= 1'd0;
        endpt0_dat  <= 8'd0;
		
        s_uart1_en <= 1'b0;
//        s_uart2_en <= 1'b0;
//        s_uart3_en <= 1'b0;
//        s_uart4_en <= 1'b0;
//        s_uart5_en <= 1'b0;
//        s_uart6_en <= 1'b0;
//        s_uart7_en <= 1'b0;

        jtag_tck_div  <= 8'd1;
    end
    else begin
        if (setup_active) begin
            if (usb_rxval) begin
                case (stage)
                    8'd0 : begin
                        s_req_type <= usb_rxdat;
                        stage <= stage + 8'd1;
                        sub_stage <= 8'd0;
                        endpt0_send <= 1'd0;
                    end
                    8'd1 : begin
                        s_req_code <= usb_rxdat;
                        stage <= stage + 8'd1;

                        jtag_base_addr <= usb_rxdat; 
                    end
                    8'd2 : begin
                        if (s_req_code == SET_CONTROL_LINE_STATE) begin
                            s_ctl_sig[7:0] <= usb_rxdat;
                        end
                        stage <= stage + 8'd1;

                        jtag_offect_addr <= usb_rxdat; 
                    end
                    8'd3 : begin
                        if (s_req_code == SET_CONTROL_LINE_STATE) begin
                            s_ctl_sig[15:8] <= usb_rxdat;
                        end
                        stage <= stage + 8'd1;
                    end
                    8'd4 : begin
                        stage <= stage + 8'd1;
                        if (s_req_code == SET_LINE_CODING) begin
                            s_interface_num[7:0] <= usb_rxdat;
                        end
                        else if (s_req_code == SET_CONTROL_LINE_STATE) begin
                            s_interface_num[7:0] <= usb_rxdat;
                        end
                        
                        jtag_reg_1 <= usb_rxdat;
                    end
                    8'd5 : begin
                        stage <= stage + 8'd1;
                        if (s_req_code == SET_LINE_CODING) begin
                            s_interface_num[15:8] <= usb_rxdat;
                        end
                        else if (s_req_code == SET_CONTROL_LINE_STATE) begin
                            s_interface_num[15:8] <= usb_rxdat;
                        end

                    end
                    8'd6 : begin
                        if (s_req_code == SET_LINE_CODING) begin
                            s_set_len[7:0] <= usb_rxdat;
                        end
                        else if (s_req_code == GET_LINE_CODING) begin
                            s_set_len[7:0] <= usb_rxdat;
                            if (s_interface_num < 8) begin
                                endpt0_send <= 1'd1;
                            end
                        end
                        else if (s_req_code == SET_CONTROL_LINE_STATE) begin
                            if (s_interface_num==INTERFACE_UART1) begin
                                s_uart1_en <= s_ctl_sig[0];
                            end
//                            else if (s_interface_num==INTERFACE_UART2) begin
//                                s_uart2_en <= s_ctl_sig[0];
//                            end
//                            else if (s_interface_num==INTERFACE_UART3) begin
//                                s_uart3_en <= s_ctl_sig[0];
//                            end
//							else if (s_interface_num==INTERFACE_UART4) begin
//                                s_uart4_en <= s_ctl_sig[0];
//                            end
//                            else if (s_interface_num==INTERFACE_UART5) begin
//                                s_uart5_en <= s_ctl_sig[0];
//                            end
//							else if (s_interface_num==INTERFACE_UART6) begin
//                                s_uart6_en <= s_ctl_sig[0];
//                            end
//                            else if (s_interface_num==INTERFACE_UART7) begin
//                                s_uart7_en <= s_ctl_sig[0];
//                            end
                        end
                        stage <= stage + 8'd1;
                    end
                    8'd7 : begin
                        if (s_req_code == SET_LINE_CODING) begin
                            s_set_len[15:8] <= usb_rxdat;
                        end
                        else if (s_req_code == GET_LINE_CODING) begin
                            s_set_len[15:8] <= usb_rxdat;
                            if (s_interface_num < 8) begin
                                endpt0_send <= 1'd1;
                            end
                            if(s_interface_num==INTERFACE_UART1)
                                endpt0_dat <= s_dte1_rate[7:0];
//                            else if(s_interface_num==INTERFACE_UART2)
//                                endpt0_dat <= s_dte2_rate[7:0];
//                            else if(s_interface_num==INTERFACE_UART3)
//                                endpt0_dat <= s_dte3_rate[7:0];
//							else if(s_interface_num==INTERFACE_UART4)
//                                endpt0_dat <= s_dte4_rate[7:0];
//                            else if(s_interface_num==INTERFACE_UART5)
//                                endpt0_dat <= s_dte5_rate[7:0];
//							else if(s_interface_num==INTERFACE_UART6)
//                                endpt0_dat <= s_dte6_rate[7:0];
//                            else if(s_interface_num==INTERFACE_UART7)
//                                endpt0_dat <= s_dte7_rate[7:0];
                        end
                        stage <= stage + 8'd1;
                        sub_stage <= 8'd0;
                    end
//                    8'd8 : begin
//                        ;
//                    end
                endcase
            end
        end
        else if (s_req_type == 8'hA0) begin //config  JTAG REG
            stage <= 8'd0;
            //JTAG config
            if(s_req_type == 8'hA0 && jtag_base_addr == 8'h01 && jtag_offect_addr == 8'h00 && jtag_reg_1 < 8'd128)begin
                jtag_tck_div  <= jtag_reg_1; 
            end
        end
        else if (s_req_code == SET_LINE_CODING) begin
            stage <= 8'd0;
            if ((usb_rxact)&&(endpt_sel ==ENDPT_UART_CONFIG)) begin
                if (usb_rxval) begin
                    sub_stage <= sub_stage + 8'd1;
                    if(s_interface_num==INTERFACE_UART1)begin
                        if (sub_stage <= 3) begin
                            s_dte1_rate <= {usb_rxdat,s_dte1_rate[31:8]};
                        end
                        else if (sub_stage == 4) begin
                            s_char1_format <= usb_rxdat;
                        end
                        else if (sub_stage == 5) begin
                            s_parity1_type <= usb_rxdat;
                        end
                        else if (sub_stage == 6) begin
                            s_data1_bits <= usb_rxdat;
                        end
                    end
//                    else if(s_interface_num==INTERFACE_UART2)begin
//                        if (sub_stage <= 3) begin
//                            s_dte2_rate <= {usb_rxdat,s_dte2_rate[31:8]};
//                        end
//                        else if (sub_stage == 4) begin
//                            s_char2_format <= usb_rxdat;
//                        end
//                        else if (sub_stage == 5) begin
//                            s_parity2_type <= usb_rxdat;
//                        end
//                        else if (sub_stage == 6) begin
//                            s_data2_bits <= usb_rxdat;
//                        end
//                    end
//                    else if(s_interface_num==INTERFACE_UART3)begin
//                        if (sub_stage <= 3) begin
//                            s_dte3_rate <= {usb_rxdat,s_dte3_rate[31:8]};
//                        end
//                        else if (sub_stage == 4) begin
//                            s_char3_format <= usb_rxdat;
//                        end
//                        else if (sub_stage == 5) begin
//                            s_parity3_type <= usb_rxdat;
//                        end
//                        else if (sub_stage == 6) begin
//                            s_data3_bits <= usb_rxdat;
//                        end
//                    end
//					else if(s_interface_num==INTERFACE_UART4)begin
//                        if (sub_stage <= 3) begin
//                            s_dte4_rate <= {usb_rxdat,s_dte4_rate[31:8]};
//                        end
//                        else if (sub_stage == 4) begin
//                            s_char4_format <= usb_rxdat;
//                        end
//                        else if (sub_stage == 5) begin
//                            s_parity4_type <= usb_rxdat;
//                        end
//                        else if (sub_stage == 6) begin
//                            s_data4_bits <= usb_rxdat;
//                        end
//                    end
//					else if(s_interface_num==INTERFACE_UART5)begin
//                        if (sub_stage <= 3) begin
//                            s_dte5_rate <= {usb_rxdat,s_dte5_rate[31:8]};
//                        end
//                        else if (sub_stage == 4) begin
//                            s_char5_format <= usb_rxdat;
//                        end
//                        else if (sub_stage == 5) begin
//                            s_parity5_type <= usb_rxdat;
//                        end
//                        else if (sub_stage == 6) begin
//                            s_data5_bits <= usb_rxdat;
//                        end
//                    end
//					else if(s_interface_num==INTERFACE_UART6)begin
//                        if (sub_stage <= 3) begin
//                            s_dte6_rate <= {usb_rxdat,s_dte6_rate[31:8]};
//                        end
//                        else if (sub_stage == 4) begin
//                            s_char6_format <= usb_rxdat;
//                        end
//                        else if (sub_stage == 5) begin
//                            s_parity6_type <= usb_rxdat;
//                        end
//                        else if (sub_stage == 6) begin
//                            s_data6_bits <= usb_rxdat;
//                        end
//                    end
//					else if(s_interface_num==INTERFACE_UART7)begin
//                        if (sub_stage <= 3) begin
//                            s_dte7_rate <= {usb_rxdat,s_dte7_rate[31:8]};
//                        end
//                        else if (sub_stage == 4) begin
//                            s_char7_format <= usb_rxdat;
//                        end
//                        else if (sub_stage == 5) begin
//                            s_parity7_type <= usb_rxdat;
//                        end
//                        else if (sub_stage == 6) begin
//                            s_data7_bits <= usb_rxdat;
//                        end
//                    end
                end
            end
        end
        else if (s_req_code == GET_LINE_CODING) begin
            stage <= 8'd0;
            if ((usb_txact)&&(endpt_sel ==ENDPT_UART_CONFIG)) begin
                if (endpt0_send == 1'b1) begin
                    if (usb_txpop) begin
                        sub_stage <= sub_stage + 8'd1;
                    end
                    if (s_req_code == GET_LINE_CODING) begin
                        if (usb_txpop) begin// new controller version
                            if(s_interface_num==INTERFACE_UART1)begin
                                if (sub_stage <= 0) begin
                                    endpt0_dat <= s_dte1_rate[15:8];
                                end
                                else if (sub_stage == 1) begin
                                    endpt0_dat <= s_dte1_rate[23:16];
                                end
                                else if (sub_stage == 2) begin
                                    endpt0_dat <= s_dte1_rate[31:24];
                                end
                                else if (sub_stage == 3) begin
                                    endpt0_dat <= s_char1_format;
                                end
                                else if (sub_stage == 4) begin
                                    endpt0_dat <= s_parity1_type;
                                end
                                else if (sub_stage == 5) begin
                                    endpt0_dat <= s_data1_bits;
                                end
                                else if (sub_stage == 6) begin
                                    endpt0_send <= 1'b0;
                                end
                                else begin
                                    endpt0_send <= 1'b0;
                                end
                            end
//                            else if(s_interface_num==INTERFACE_UART2)begin
//                                if (sub_stage <= 0) begin
//                                    endpt0_dat <= s_dte2_rate[15:8];
//                                end
//                                else if (sub_stage == 1) begin
//                                    endpt0_dat <= s_dte2_rate[23:16];
//                                end
//                                else if (sub_stage == 2) begin
//                                    endpt0_dat <= s_dte2_rate[31:24];
//                                end
//                                else if (sub_stage == 3) begin
//                                    endpt0_dat <= s_char2_format;
//                                end
//                                else if (sub_stage == 4) begin
//                                    endpt0_dat <= s_parity2_type;
//                                end
//                                else if (sub_stage == 5) begin
//                                    endpt0_dat <= s_data2_bits;
//                                end
//                                else if (sub_stage == 6) begin
//                                    endpt0_send <= 1'b0;
//                                end
//                                else begin
//                                    endpt0_send <= 1'b0;
//                                end
//                            end
//                            else if(s_interface_num==INTERFACE_UART3)begin
//                                if (sub_stage <= 0) begin
//                                    endpt0_dat <= s_dte3_rate[15:8];
//                                end
//                                else if (sub_stage == 1) begin
//                                    endpt0_dat <= s_dte3_rate[23:16];
//                                end
//                                else if (sub_stage == 2) begin
//                                    endpt0_dat <= s_dte3_rate[31:24];
//                                end
//                                else if (sub_stage == 3) begin
//                                    endpt0_dat <= s_char3_format;
//                                end
//                                else if (sub_stage == 4) begin
//                                    endpt0_dat <= s_parity3_type;
//                                end
//                                else if (sub_stage == 5) begin
//                                    endpt0_dat <= s_data3_bits;
//                                end
//                                else if (sub_stage == 6) begin
//                                    endpt0_send <= 1'b0;
//                                end
//                                else begin
//                                    endpt0_send <= 1'b0;
//                                end
//                            end
//							else if(s_interface_num==INTERFACE_UART4)begin
//                                if (sub_stage <= 0) begin
//                                    endpt0_dat <= s_dte4_rate[15:8];
//                                end
//                                else if (sub_stage == 1) begin
//                                    endpt0_dat <= s_dte4_rate[23:16];
//                                end
//                                else if (sub_stage == 2) begin
//                                    endpt0_dat <= s_dte4_rate[31:24];
//                                end
//                                else if (sub_stage == 3) begin
//                                    endpt0_dat <= s_char4_format;
//                                end
//                                else if (sub_stage == 4) begin
//                                    endpt0_dat <= s_parity4_type;
//                                end
//                                else if (sub_stage == 5) begin
//                                    endpt0_dat <= s_data4_bits;
//                                end
//                                else if (sub_stage == 6) begin
//                                    endpt0_send <= 1'b0;
//                                end
//                                else begin
//                                    endpt0_send <= 1'b0;
//                                end
//                            end
//							else if(s_interface_num==INTERFACE_UART5)begin
//                                if (sub_stage <= 0) begin
//                                    endpt0_dat <= s_dte5_rate[15:8];
//                                end
//                                else if (sub_stage == 1) begin
//                                    endpt0_dat <= s_dte5_rate[23:16];
//                                end
//                                else if (sub_stage == 2) begin
//                                    endpt0_dat <= s_dte5_rate[31:24];
//                                end
//                                else if (sub_stage == 3) begin
//                                    endpt0_dat <= s_char5_format;
//                                end
//                                else if (sub_stage == 4) begin
//                                    endpt0_dat <= s_parity5_type;
//                                end
//                                else if (sub_stage == 5) begin
//                                    endpt0_dat <= s_data5_bits;
//                                end
//                                else if (sub_stage == 6) begin
//                                    endpt0_send <= 1'b0;
//                                end
//                                else begin
//                                    endpt0_send <= 1'b0;
//                                end
//                            end
//							else if(s_interface_num==INTERFACE_UART6)begin
//                                if (sub_stage <= 0) begin
//                                    endpt0_dat <= s_dte6_rate[15:8];
//                                end
//                                else if (sub_stage == 1) begin
//                                    endpt0_dat <= s_dte6_rate[23:16];
//                                end
//                                else if (sub_stage == 2) begin
//                                    endpt0_dat <= s_dte6_rate[31:24];
//                                end
//                                else if (sub_stage == 3) begin
//                                    endpt0_dat <= s_char6_format;
//                                end
//                                else if (sub_stage == 4) begin
//                                    endpt0_dat <= s_parity6_type;
//                                end
//                                else if (sub_stage == 5) begin
//                                    endpt0_dat <= s_data6_bits;
//                                end
//                                else if (sub_stage == 6) begin
//                                    endpt0_send <= 1'b0;
//                                end
//                                else begin
//                                    endpt0_send <= 1'b0;
//                                end
//                            end
//							else if(s_interface_num==INTERFACE_UART7)begin
//                                if (sub_stage <= 0) begin
//                                    endpt0_dat <= s_dte7_rate[15:8];
//                                end
//                                else if (sub_stage == 1) begin
//                                    endpt0_dat <= s_dte7_rate[23:16];
//                                end
//                                else if (sub_stage == 2) begin
//                                    endpt0_dat <= s_dte7_rate[31:24];
//                                end
//                                else if (sub_stage == 3) begin
//                                    endpt0_dat <= s_char7_format;
//                                end
//                                else if (sub_stage == 4) begin
//                                    endpt0_dat <= s_parity7_type;
//                                end
//                                else if (sub_stage == 5) begin
//                                    endpt0_dat <= s_data7_bits;
//                                end
//                                else if (sub_stage == 6) begin
//                                    endpt0_send <= 1'b0;
//                                end
//                                else begin
//                                    endpt0_send <= 1'b0;
//                                end
//                            end
                        end
                    end
                end
            end
            else begin
                sub_stage <= 8'd0;
            end
        end
        else begin
             stage <= 8'd0;
             sub_stage <= 8'd0;
        end
    end
end


assign jtag_tck = (jtag_tck_div == 8'd0)? PHY_CLKOUT : jtag_tck_bf;
always @(posedge PHY_CLKOUT,posedge RESET_IN) begin
    if (RESET_IN) begin
        jtag_tck_bf <= 1'b0;
    end
    else if( jtag_tck_div <= 8'd1) begin
        jtag_tck_bf <= ~jtag_tck_bf;
    end
    else begin
        if((jtag_tck_div - 1'b1) == jtag_tck_cnt) begin
            jtag_tck_bf <= ~jtag_tck_bf;
            jtag_tck_cnt <= 8'd0;
        end
        else begin
            jtag_tck_cnt <= jtag_tck_cnt + 1'd1;
        end
    end
end


endmodule
