/*
 * *****************************************************************************************
 *
 * 		Copyright (C) 2014-2023 Gowin Semiconductor Technology Co.,Ltd.
 *
 * @file		gw_usb2uart.h
 * @author		Embedded System R&D Department
 * @version		V1.0.0
 * @date		2023-05-30 09:00:00
 * @brief		Gowin USB2UART API.
 ******************************************************************************************
 */

#ifndef GW_USB2UART_H_
#define GW_USB2UART_H_


//Cross platform
#if defined(_WIN32) || defined(__CYGWIN__)
#ifndef DLLIMPORT
#define DLLIMPORT __declspec(dllexport)
#endif
#else
#define DLLIMPORT
#endif



/* Includes ------------------------------------------------------------------------------------------------------------- */
#include "libusb.h"

#if defined(__cplusplus)
extern "C" {
#endif

/* Definitions ---------------------------------------------------------------------------------------------------------- */
//See device management !!!
#define UART_COM_PORT         53

int usb2uart_vcp_async(void);

#if defined(__cplusplus)
}
#endif

#endif // GW_USB2UART_H_
